/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints;

import edu.kit.ipd.descartes.core.Entity;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Set Of Configurations</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Use this to model any unspecific variation, for example the deployment of nodes on hardware.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations#getValueConstraint <em>Value Constraint</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations#getVariants <em>Variants</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getSetOfConfigurations()
 * @model
 * @generated
 */
public interface SetOfConfigurations extends VariationType {
    /**
     * Returns the value of the '<em><b>Value Constraint</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Value Constraint</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Value Constraint</em>' containment reference.
     * @see #setValueConstraint(OclConstraint)
     * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getSetOfConfigurations_ValueConstraint()
     * @model containment="true" required="true"
     * @generated
     */
    OclConstraint getValueConstraint();

    /**
     * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations#getValueConstraint <em>Value Constraint</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Value Constraint</em>' containment reference.
     * @see #getValueConstraint()
     * @generated
     */
    void setValueConstraint(OclConstraint value);

    /**
     * Returns the value of the '<em><b>Variants</b></em>' reference list.
     * The list contents are of type {@link edu.kit.ipd.descartes.core.Entity}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Variants</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Variants</em>' reference list.
     * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getSetOfConfigurations_Variants()
     * @model
     * @generated
     */
    EList<Entity> getVariants();

} // SetOfConfigurations
