/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository;

import edu.kit.ipd.descartes.core.Connector;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Assembly Connector</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getInterfaceRequiringRole <em>Interface Requiring Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getInterfaceProvidingRole <em>Interface Providing Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getProvidingAssemblyContext <em>Providing Assembly Context</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getRequiringAssemblyContext <em>Requiring Assembly Context</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyConnector()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AssemblyConnectorsReferencedInterfaceProvidingRolesAndChildContextMustMatch AssemblyConnectorsReferencedInterfaceRequiringRoleAndChildContextMustMatch AssemblyConnectorsReferencedInterfacesMustMatch'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot AssemblyConnectorsReferencedInterfaceProvidingRolesAndChildContextMustMatch='\n\t\t\tself.providingAssemblyContext.encapsulatedComponent.interfaceProvidingRoles->includes(self.interfaceProvidingRole)' AssemblyConnectorsReferencedInterfaceRequiringRoleAndChildContextMustMatch='\n\t\t\tself.requiringAssemblyContext.encapsulatedComponent.interfaceRequiringRoles->includes(self.interfaceRequiringRole)' AssemblyConnectorsReferencedInterfacesMustMatch='self.interfaceProvidingRole.interface = self.interfaceRequiringRole.interface'"
 * @generated
 */
public interface AssemblyConnector extends Connector {
	/**
	 * Returns the value of the '<em><b>Parent Structure</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getAssemblyConnectors <em>Assembly Connectors</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent Structure</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent Structure</em>' container reference.
	 * @see #setParentStructure(ComposedStructure)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyConnector_ParentStructure()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getAssemblyConnectors
	 * @model opposite="assemblyConnectors" required="true" transient="false"
	 * @generated
	 */
	ComposedStructure getParentStructure();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getParentStructure <em>Parent Structure</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent Structure</em>' container reference.
	 * @see #getParentStructure()
	 * @generated
	 */
	void setParentStructure(ComposedStructure value);

	/**
	 * Returns the value of the '<em><b>Interface Requiring Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Requiring Role</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface Requiring Role</em>' reference.
	 * @see #setInterfaceRequiringRole(InterfaceRequiringRole)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyConnector_InterfaceRequiringRole()
	 * @model required="true"
	 * @generated
	 */
	InterfaceRequiringRole getInterfaceRequiringRole();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getInterfaceRequiringRole <em>Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interface Requiring Role</em>' reference.
	 * @see #getInterfaceRequiringRole()
	 * @generated
	 */
	void setInterfaceRequiringRole(InterfaceRequiringRole value);

	/**
	 * Returns the value of the '<em><b>Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Providing Role</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface Providing Role</em>' reference.
	 * @see #setInterfaceProvidingRole(InterfaceProvidingRole)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyConnector_InterfaceProvidingRole()
	 * @model required="true"
	 * @generated
	 */
	InterfaceProvidingRole getInterfaceProvidingRole();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getInterfaceProvidingRole <em>Interface Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interface Providing Role</em>' reference.
	 * @see #getInterfaceProvidingRole()
	 * @generated
	 */
	void setInterfaceProvidingRole(InterfaceProvidingRole value);

	/**
	 * Returns the value of the '<em><b>Providing Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Providing Assembly Context</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Providing Assembly Context</em>' reference.
	 * @see #setProvidingAssemblyContext(AssemblyContext)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyConnector_ProvidingAssemblyContext()
	 * @model required="true"
	 * @generated
	 */
	AssemblyContext getProvidingAssemblyContext();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getProvidingAssemblyContext <em>Providing Assembly Context</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Providing Assembly Context</em>' reference.
	 * @see #getProvidingAssemblyContext()
	 * @generated
	 */
	void setProvidingAssemblyContext(AssemblyContext value);

	/**
	 * Returns the value of the '<em><b>Requiring Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Requiring Assembly Context</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Requiring Assembly Context</em>' reference.
	 * @see #setRequiringAssemblyContext(AssemblyContext)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyConnector_RequiringAssemblyContext()
	 * @model required="true"
	 * @generated
	 */
	AssemblyContext getRequiringAssemblyContext();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector#getRequiringAssemblyContext <em>Requiring Assembly Context</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Requiring Assembly Context</em>' reference.
	 * @see #getRequiringAssemblyContext()
	 * @generated
	 */
	void setRequiringAssemblyContext(AssemblyContext value);

} // AssemblyConnector
